/**
	$Id: SuggestedFilenameGenerator.java 5212 2010-01-12 13:21:49Z nicklas $

	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.bfs;

/**
	File name generator implementation that uses the suggested file name.
	The implementation returns the suggested file name after making sure 
	that it is unique. Non-unique suggestions are transformed with a simple
	algorithm that adds a sequence number to the file name. Eg. if the file
	name 'example.txt' is suggested three times, this generator will return
	'example.txt', 'example-2.txt', 'example-3.txt'.

	@author Nicklas
	@version 2.15
	@base.modified $Date: 2010-01-12 14:21:49 +0100 (ti, 12 jan 2010) $
*/
public class SuggestedFilenameGenerator
	extends AbstractFilenameGenerator<Object>
{

	public SuggestedFilenameGenerator()
	{}
	
	/*
		From the FilenameGenerator interface
		------------------------------------
	*/
	@Override
	public String getNextFilename(Object owner, String suggestedFilename)
	{
		return makeUnique(suggestedFilename);
	}
	// -----------------------------------	
}
