<%-- $Id: view_bioassay.jsp 6962 2015-10-01 12:29:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RootRawBioAssay"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.HashMap"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final Item itemType = Item.BIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String tabId = Values.getString(request.getParameter("tab"), "properties");
final DbControl dc = sc.newDbControl();
try
{
	BioAssay bioAssay = BioAssay.getById(dc, itemId);
	final boolean hasDbSpots = bioAssay.getNumSpots() > 0;
	BioAssaySet bioAssaySet = bioAssay.getBioAssaySet();
	Experiment experiment = bioAssay.getExperiment();
	String title = null;
	final boolean writePermission = bioAssay.hasPermission(Permission.WRITE);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioAssay);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~bioassays.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Experiments" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../bioassaysets/index.jsp?ID="+ID+"&amp;experiment_id="+experiment.getId()%>"
			/><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&amp;bioassayset_id="+bioAssaySet.getId()%>" 
			/><p:pathelement title="<%=HTML.encodeTags(bioAssay.getName())%>"
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>

		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol"
			active="<%=tabId%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this bioassay" : "You do not have permission to edit this bioassay"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<tbl:button
							id="btnPlotter"
							image="plotter.png"
							title="Plot tool&hellip;"
							tooltip="A simple tool for generating plots"
							visible="<%=hasDbSpots%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="bioassay.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(bioAssay.getName())%></td>
			</tr>
			<tr>
				<th>Spots</th>
				<td>db: <%=bioAssay.getNumSpots()%>; file: <%=bioAssay.getNumFileSpots()%></td>
			</tr>
			<tr >
				<th>Description</th>
				<td><%=HTML.encodeTags(bioAssay.getDescription())%></td>
			</tr>
			</table>
			</div>

			<jsp:include page="../../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="BIOASSAYSET" />
				<jsp:param name="item_id" value="<%=bioAssaySet.getId()%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		
			<%
			ItemQuery<RootRawBioAssay> rawQuery = bioAssay.getRootRawBioAssays();
			rawQuery.include(Include.MINE, Include.SHARED, Include.OTHERS, Include.IN_PROJECT);
			rawQuery.order(Orders.asc(Hql.property("rawBioAssay.name")));
			ItemResultList<RootRawBioAssay> rawBioAssays = rawQuery.list(dc);
			%>
			<base:section
				id="rawBioAssaySection"
				title="<%="Root raw bioassays (" + rawBioAssays.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (rawBioAssays.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					No raw bioassays are linked to this bioassay
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="rawBioAssays"
						columns="all"
						>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef
							id="spots"
							title="Spots"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<%
						ItemQuery<AnnotationType> efQuery = experiment.getExperimentalFactors();
						efQuery.include(Include.ALL);
						efQuery.order(Orders.asc(Hql.property("name")));
						ItemResultList<AnnotationType> experimentalFactors = efQuery.list(dc);
						for (AnnotationType at : experimentalFactors)
						{
							Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
							%>
							<tbl:columndef
								id="<%="at"+at.getId()%>"
								title="<%=HTML.encodeTags(at.getName())%>"
								formatter="<%=formatter%>"
							/>
							<%
						}
						%>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							SnapshotManager manager = new SnapshotManager();
							AnnotationTypeFilter annotationTypeFilter = new AnnotationTypeFilter();
							for (RootRawBioAssay item : rawBioAssays)
							{
								RawBioAssay rba = item.getRawBioAssay();
								AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
								AnnotationSetSnapshot snapshot = as == null ? null : manager.getSnapshot(dc, as.getId());
								%>
								<tbl:row>
									<tbl:cell column="name"><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
									<tbl:cell column="spots"><%=rba.getSpots()%></tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
									<%
									for (AnnotationType at : experimentalFactors)
									{
										Unit unit = at.getDefaultUnit();
										String unitSymbol = unit == null ? "" : "&nbsp;" + unit.getDisplaySymbol();
										
										annotationTypeFilter.setAnnotationType(at);
										List<AnnotationSnapshot> all = snapshot == null ? 
												null : manager.findAnnotations(dc, snapshot, annotationTypeFilter, true);
										%>
										<tbl:cell column="<%="at"+at.getId()%>">
											<%
											if (all != null && all.size() > 0)
											{
												for (AnnotationSnapshot a : all)
												{
													List values = a.getActualValues();
													boolean isUpToDate = a.isUpToDate();
													%>
													<tbl:cellvalue list="<%=values%>" suffix="<%=unitSymbol%>"/>
													<base:icon 
														subclass="link auto-init"
														data-auto-init="edit-experimental-factor"
														data-item-type="<%=a.getThisItemType().name()%>"
														data-item-id="<%=a.getThisItemId() %>"
														data-annotation-type="<%=at.getId() %>"
														data-annotation="<%=a.getThisAnnotationId()%>"
														visible="<%=writePermission%>"
														image="<%=isUpToDate ? "edit.png" : "edit-outofsync.png"%>" 
														tooltip="Modify the values of this experimental factor"
													/>
													<%
												}
											}
											%>
										</tbl:cell>
										<%
									}
									%>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<jsp:include page="../../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this bioassay" />
			</jsp:include>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values" clazz="white">
			<jsp:include page="../../../common/annotations/list_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>

		<t:tab id="spotdata" title="Spot data" visible="<%=hasDbSpots%>">
			<div class="bg-filled-50 absolutefull">
				<table style="margin: auto; height: 100%;"><tr><td>
				<b>Please wait. The spot data is loading...</b>
				</td></tr></table>
			</div>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
