/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var ExtraValues = function()
{
	var extravalues = {};
	
	/**
		Initialize the page.
	*/
	extravalues.initPage = function()
	{
		var pageId = Doc.getPageId();
		if (pageId == 'view-page')
		{
			var itemId = Data.get('page-data', 'item-id');
			var attributes = {'item-type': 'EXTRAVALUE', 'item-id': itemId};
			
			Buttons.addClickHandler('btnDelete', extravalues.deleteItem);
			Buttons.addClickHandler('btnCopy', extravalues.copyJob);
			Buttons.addClickHandler('btnExport', Buttons.runPlugin, attributes);
			Buttons.addClickHandler('btnImport', Buttons.runPlugin, attributes);
			Buttons.addClickHandler('btnRunPlugin', Buttons.runPlugin, attributes);
			
		}
	}
	
	extravalues.deleteItem = function()
	{
		if (confirm('Extra values are deleted immediately and cannot be restored. Do you want to continue?'))
		{
			var url = 'index.jsp?ID='+App.getSessionId();
			url += '&cmd=DeleteItem&item_id='+Data.get('page-data', 'item-id');
			location.replace(url);
		}
	}
	
	extravalues.copyJob = function()
	{
		var url = '../../../common/plugin/index.jsp?ID='+App.getSessionId();
		url += '&cmd=CopyJob&job_id='+Data.get('page-data', 'job-id');
		url += '&item_type=BIOASSAYSET&context_type=LIST';
		Dialogs.openPopup(url, 'CopyJob', 750, 500);
	}

	return extravalues;
}();

Doc.onLoad(ExtraValues.initPage);

